/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * Enhanced C++ component implementation for business interface Service1,
 * where the implementation also has a single reference using the Service1
 * interface and which gets called when operation1 is invoked
 * @author Bryan Aupperle
 *
 */

#include "Service1Impl3.h"
#include "..\ComponentContext.h"
#include "..\SDO.h"
using namespace oasis::sca;

// Construction/Destruction

Service1Impl3::Service1Impl3()
{
	ComponentContextPtr context = ComponentContext::getCurrent();

	DataObjectPtr properties = context->getProperties();

	serviceName = properties->getString("serviceName");
	
	return;
}


Service1Impl3::~Service1Impl3()
{
	return; 
}

// Implementation

std::string Service1Impl3::operation1(const std::string input) {
	std::string result;

	ComponentContextPtr context = ComponentContext::getCurrent();

	std::list<ServiceProxyPtr> service = context->getServices("reference1");
	std::list<ServiceProxyPtr>::iterator service_iter;

	reference1.clear();	
	Service1ProxyPtr reference;
	for(service_iter = service.begin(); service_iter != service.end(); service_iter++) {
    		
		reference = dynamicCast<Service1Proxy>(*service_iter);
		if (reference) {
			reference1.push_back(reference);
			result.append(reference->operation1(input));
		}
    }
    
	return serviceName + " operation1 invoked" + " " + result;
}
