/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * Enhanced C++ component implementation header for business interface Service1,
 * where the implementation also has a single reference using the Service1
 * interface with mutiplicity 0..n all of which and which get called when 
 * operation1 is invoked
 * @author Bryan Aupperle
 *
 */

#include "Service1.h"
#include "Service1Proxy.h"
#include <string>
#include <list>

class Service1Impl4 : public Service1 {
public:
	// @Property
	std::string serviceName;

	// Required = false + a list -> multiplicity 0..n
	// @Reference(interfaceHeader="Service1.h" required="false")
	std::list<Service1ProxyPtr> reference1;

	Service1Impl4();
	virtual ~Service1Impl4();

	virtual std::string operation1(const std::string input);

};
