/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * Enhanced C++ component implementation header for business interface Service1,
 * where the implementation also has a single reference using the Service1
 * interface with multiplicity 0..1 which gets called when 
 * operation1 is invoked, if present

 * @author Bryan Aupperle
 *
 */

#include "Service1.h"
#include "Service1Proxy.h"
#include <string>

class Service1Impl6 : public Service1 {
public:
	// @Property
	std::string serviceName;

	// Required = false -> multiplicity 0..1
	// @Reference(interfaceHeader="Service1.h" required="false")
	Service1ProxyPtr reference1;

	Service1Impl6();
	virtual ~Service1Impl6();

	virtual std::string operation1(const std::string input);

};
